import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.StringTokenizer;
//import org.apache.commons.lang.StringEscapeUtils;

public class ConvertToXML_Char {
	
	public static int MAXB = 50000;

	public static void main(String[] args) {
		String templateXML = args[0];
		String csvFile = args[1];
		String propsFile = args[2];
		String outXMLFile = args[3];
		
		//debug(); if(true) return;
		
		//maintainPartyTEMPLATE.xml fsk.csv configFSK.txt mpFSK.xml
		//java -cp "bin:lib/org.apache.commons.lang_2.6.0.jar" ConvertToXML maintainPartyTEMPLATE.xml fsk.csv configFSK.txt mpFSK.xml
		//java -cp "bin:lib/org.apache.commons.lang_2.6.0.jar" ConvertToXML maintainPartyTEMPLATE.xml alka.csv configALKA.txt mpALKA.xml

		try {
			HashMap props = parsePropertyFile(propsFile); 
			parseXMLTemplate(templateXML, csvFile, outXMLFile, props );
			System.out.println();
			System.out.println("Done");
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	static void debug() {
		char[] chars = new char[5];
		chars[0] = '0'; chars[1] = '1'; //chars[2] = '2'; 
		System.out.println(chars[0]);		System.out.println(chars[1]);		System.out.println(chars[2]);
		change1(chars);
		System.out.println(chars[0]);		System.out.println(chars[1]);		System.out.println(chars[2]);
		chars = change2(chars);
		System.out.println(chars[0]);		System.out.println(chars[1]);		System.out.println(chars[2]);
	}
	static void change1( char[] chars ) {
		chars[0] = 'A';
		chars[1] = 'B';
		chars[2] = 'C';
	}
	static char[] change2( char[] chars ) {
		char[] charsX = new char[10];
		charsX[0] = 'a';
		charsX[1] = 'b';
		charsX[2] = 'c';
		return charsX;
	}

	public static void parseXMLTemplate(String templateXML, String csvFile, String XMLFile, HashMap props) throws IOException {

		StringBuffer mpTemplateXML = new StringBuffer();
		mpTemplateXML = parseTemplate(templateXML);


		//FileReader rs = new FileReader(csvFile);
		//BufferedReader csvIn = new BufferedReader(rs);
		
		File rs = new File(csvFile);
	
		
		  //BufferedReader br = new BufferedReader(new FileReader(rs));  // no difference 32..65533
		  //int st; 
		  //while ((st = br.read() ) != -1) {
		  //  System.out.println((char)st); 
		  //}
		
		  //FileReader fr =  new FileReader(csvFile);   // no difference 32..65533
		  //  int i; 
		  //  while ((i=fr.read()) != -1) 
		  //    System.out.println(i); 
		   	
		//FileInputStream is = new FileInputStream(csvFile);
		//InputStreamReader isr = new InputStreamReader(is, "Windows-1252");
		//BufferedReader buffReader = new BufferedReader(isr);
		//int i; 
		//while ((i=buffReader.read()) != -1) 
		//   System.out.println((char)i); 
		
	    //if(true) return;
	
		
		BufferedReader csvIn = new BufferedReader( new InputStreamReader( new FileInputStream(rs), "Windows-1252") );
		
		try {
			createBatchXML(csvIn, mpTemplateXML, XMLFile, props );
		} catch (Exception e) {
			System.out.println(e.getMessage());
			e.printStackTrace();
			System.exit(-1);
		}

	}
	public static void createBatchXML(BufferedReader csvIn,	StringBuffer mpTemplateXML,	String XMLFile, HashMap props) throws IOException {
		int j = 1;
		int value = 0, i=0;
		char[] item = new char[MAXB];
		BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(XMLFile),"UTF-8"));
		bw.write("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");bw.newLine();

		// reads to the end of the stream 
		while((value = csvIn.read()) != -1) {

			//if( value == 65533) {
			//	value = 248;
			//}
			// converts int to character
			char c = (char)value;
			//System.out.println(c+" "+value+" ");
			
			if( c == '\n' || c == '\r') {
				//debugCharArray(item);
				OutputDOT(j++);
				createBatchXML( item, mpTemplateXML, XMLFile, props, bw);
				i=0;
				item = new char[MAXB];
			}
			else
				item[i++] = (char) c;
			
		}
		if( item != null )
			createBatchXML( item, mpTemplateXML, XMLFile, props, bw);

		bw.close();
	}
	
	public static void createBatchXML(char[] item,	StringBuffer mpTemplateXML,	String XMLFile, HashMap props, BufferedWriter bw) throws IOException {
		String[] inceptionDate;
		String[] expiryDate;
		String company = "";
		//List values = new ArrayList();
			
			try {
				
				//bw.write(item); bw.newLine(); if(true) continue;
				
				char[] newXML_Txn = new char[MAXB];
				mpTemplateXML.getChars(0, mpTemplateXML.length(), newXML_Txn, 0);
				
				char[][] csvItems = splitCharArray(item,'|') ; //item.toString().split("\\|");
				
				if( csvItems == null || csvItems.length == 0 )
					return;
				
				//int l1 = getLength(newXML_Txn);
				newXML_Txn = processCSVLine( csvItems, newXML_Txn, props  );
				int l2 = getLength(newXML_Txn);
				//bw.write(newXML_Txn.toString().trim());
				
				String x = getString(newXML_Txn,l2);
				bw.write(x);
				
				//bw.newLine();
				
			} catch (NumberFormatException e) {
				e.printStackTrace();
			}
	}

	private static String getString(char[] ch, int l2) {
		StringBuffer x = new StringBuffer();
		for( int i=0; i<l2; i++) {
			x.append(ch[i]);
		}
		return x.toString();
	}

	private static char[][] splitCharArray(char[] item, char delimiter) {
		int tokens = countTokens(item,delimiter);
		if( tokens == 0 )
			return null;
		char[][] retVal = new char[tokens+1][MAXB];
		
		int i=0, cnt = 0;
		char[] token = new char[MAXB];
		for (char ch : item) {
			
			if( ch == 0 )
				break;
			
			if( ch  == delimiter ) {
				retVal[cnt] = token;
				cnt++;
				i=0;
				token = new char[MAXB];
			} else 
				token[i++] = ch;
		}	
		if( getLength(token) > 0 ) {
			retVal[cnt] = token;
		}
		
		return retVal;
	}


	private static int countTokens(char[] item, char delimiter) {
		int cnt = 0 ;
		for (char ch : item) {
			if( ch == 0 )
				break;
			if( ch  == delimiter )
				cnt++;
		}
		return cnt;
	}


	private static void OutputDOT(int i) {
		if(i==1)      System.out.print("I"); 
		if(i==10)     System.out.print("X"); 
		if(i==100)    System.out.print("C"); 
		if(i==1000)   System.out.print("M"); 
		if(i==10000)  System.out.print("XM"); 
		if(i==100000) System.out.print("X2M"); 
		
		if( i< 10) {
			 System.out.print("."); return;
		}
		if( i< 100) {
			 if( (i % 10) == 0) System.out.print("."); 
			 return;
		}
		if( i< 1000) {
			 if( (i % 100) == 0) System.out.print("."); 
			 return;
		}
		if( i< 10000) {
			 if( (i % 1000) == 0) System.out.print("."); 
			 return;
		}
		if( (i % 10000) == 0) System.out.print("."); 
	}


	private static char[] processCSVLine(char[][] csvItems, char[] newXML_Txn, HashMap props) {
		// given one line of CSV values, go through all the props and replace the AA_ with the CSV value according to the props column number
		int l = csvItems.length;
		for( int i=0; i<csvItems.length; i++ ) {
			String iS = Integer.toString(i+1);
			String templateStr = (String)props.get(iS); // 2=AAA_BD : replaceStr=AAA_BD
			if( templateStr == null || templateStr.length() == 0)
				continue;
			char[] csvValue = csvItems[i]; // 1990-01-01
			newXML_Txn = replaceTemplateString( templateStr, csvValue, newXML_Txn);
		}
		
		// replace <ProvinceStateType>AAA_ADST1</ProvinceStateType> with ""
		newXML_Txn = replaceString( "<ProvinceStateType>AAA_ADST1</ProvinceStateType>".toCharArray(),  newXML_Txn );
		newXML_Txn = replaceString( "<ProvinceStateType>AAA_ADST2</ProvinceStateType>".toCharArray(),  newXML_Txn );
		newXML_Txn = replaceString( "<ProvinceStateType>AAA_ADST3</ProvinceStateType>".toCharArray(),  newXML_Txn );
		debugStr(newXML_Txn);

		
		// filter out any lines containing AAA
		newXML_Txn = filterString( "AAA".toCharArray(),  newXML_Txn );
		debugStr(newXML_Txn);
	
		return newXML_Txn;
	}

	private static char[] filterString(char[] strAAA, char[] newXML_Txn) {
		// find occurrences of strAAA.. then remove the complete line ie from start or prior '\n' to the next '\n'
		int i=0;
		while( (i = indexOf(newXML_Txn,strAAA) ) > 0 ) {
			int start = getStartOfLine( newXML_Txn, i );
			int   end = getendOfLine(   newXML_Txn, i );
			int l1 = getLength(newXML_Txn);
			newXML_Txn = removeChars(newXML_Txn,start,end);
			int l2 = getLength(newXML_Txn);
			l2 = l2;
		}
		return newXML_Txn;
	}

	// find strAAA sequence within newXML_Txn
	private static int indexOf(char[] newXML_Txn, char[] strAAA) {
		return indexOf(newXML_Txn,strAAA,0);
	}
	private static int indexOf(char[] newXML_Txn, char[] strAAA, int start) {
		int pos=start;
		int length = getLength(newXML_Txn);
		while( pos < length && newXML_Txn[pos] != 0 ) {
			if( sameCharSequence(newXML_Txn,pos,strAAA) )
				return pos;
			pos++;
		}
		return -1;
	}


	// check if the next chars in newXML_Txn from position pos are the same as strAAA
	private static boolean sameCharSequence(char[] newXML_Txn, int pos, char[] strAAA) {
		int strAAA_Length     = getLength( strAAA );
		int newXML_Txn_Length = getLength( newXML_Txn );
		if( pos + strAAA_Length >  newXML_Txn_Length )
			return false;
		for(int i=0; i < strAAA_Length && strAAA[i] != 0; i++) {
			char a = strAAA[i];
			char b = newXML_Txn[pos+i];
			if(a != b)
				return false;
		}		
		return true;
	}


	// return the index of the next '\n' char in the array
	private static int getendOfLine(char[] newXML_Txn, int i) {
		int pos=i;
		while( pos < newXML_Txn.length && newXML_Txn[pos] != 0  ) {
			if( newXML_Txn[pos] == '\n' )
				return pos+1;
			pos++;
		}
		return pos;
	}

	// return the index of the prior '\n' char in the array
	private static int getStartOfLine(char[] newXML_Txn, int i) {
		int pos=i;
		while( pos > 0 ) {
			if( newXML_Txn[pos] == '\n' )
				return pos+1;
			pos--;
		}
		return pos;
	}


	// remove char in the array between start and end
	private static char[] removeChars(char[] newXML_Txn, int start, int end) {
		char[] tmp = new char[MAXB];
		int i=0, pos=0;
		for (char ch : newXML_Txn) {
			if( ch == 0 )
				break;
			if( pos < start || pos > end )
				tmp[i++] = ch; 
			pos++;
		}
		return tmp;
	}


	private static char[] replaceString(char[] string, char[] newXML_Txn) {
		int st = indexOf( newXML_Txn, string );
		if( st  < 0 ) 
			return newXML_Txn;
		int end = st + getLength( string ) - 1;
		newXML_Txn = removeChars( newXML_Txn, st, end );
		return newXML_Txn;
	}


	private static char[] replaceTemplateString(String templateStr, char[] csvValue, char[] newXML_Txn) {
		// templateStr = AAA_BD
		// csvValue = 1990-01-01
		// templateStr AAA_BD:DATE=DD.MM.YYYY
		// templateStr AAA_AT:FIXED=1
		
		if( csvValue == null || getLength(csvValue) == 0 )
			return newXML_Txn;
		
		csvValue = makeXMLSafe(csvValue);
		
		// handle date conversions
		String[] templateArray = templateStr.split(":");
		if( templateArray.length == 2) {
			templateStr = templateArray[0];
			// convert csvValue according to date format
			csvValue = formatConvert( csvValue, templateArray[1] );
		}
		
		int st = indexOf(newXML_Txn,templateStr.toCharArray());
		if( st  < 0 ) 
			return newXML_Txn;
		int end = st + templateStr.length();
		newXML_Txn = replaceChars(newXML_Txn,st, end-1, csvValue);
		
		debugStr(newXML_Txn);
		
		return newXML_Txn;
		
	}
	private static void debugCharArray(char[] chAr) {
		//if(true) return;
		int l = getLength(chAr);
		StringBuffer hexLine = new StringBuffer("");
		StringBuffer chrLine = new StringBuffer("");
		for( int i=0; i< l; i++) {
			char ch = chAr[i];
			String hex = String.format("%04x", (int) ch);
			hexLine.append(hex+" ");
			chrLine.append(ch+"    ");
			if( ((i+1) % 16) == 0 ) {
				System.out.println(chrLine ); chrLine = new StringBuffer("");
				System.out.println(hexLine ); hexLine = new StringBuffer("");
			}
		}
		if( chrLine.length()>0){
			System.out.println(chrLine ); 
			System.out.println(hexLine ); 			
		}
		System.out.println();
		
	}

	private static void debugStr(char[] chAr) {
		if(true) return;
		int l = getLength(chAr);
		for( int i=0; i< l; i++) {
			System.out.print(chAr[i]);
		}
		System.out.println();
	}

	// replace chars between st and end in newXML_Txn with csvValue
	private static char[] replaceChars(char[] newXML_Txn, int start, int end, char[] csvValue) {
		char[] newChars = new char[MAXB];

		int i=0;
		for( int pos = 0; pos < newXML_Txn.length && newXML_Txn[pos] != 0 ; pos++) {
			if( pos < start || pos > end )
				newChars[i] = newXML_Txn[pos];
			else {
				appendChars( newChars, csvValue );
				i = getLength( newChars ) - 1;
				pos = end;
			}
			i++;
			
		}
		return newChars;
	}


	// append csvValue to the end of newChars
	private static void appendChars(char[] newChars, char[] csvValue) {
		int length = getLength( newChars );
		int i  = length;
		for (char ch : csvValue) {
			if( ch == 0 )
				break;
			newChars[i++] = ch;
		}

	}


	private static int getLength(char[] newChars) {
		int length = 0;
		for ( char ch : newChars ) {
			if( ch == 0 )
				break;
			length++;
		}
		return length;
	}


	/**
	 * There are five XML Special characters which needs to be escaped :
	 *     
	    & - &amp;
	    < - &lt;
	    > - &gt;
	    " - &quot;
	    ' - &apos;
	 */
	private static char[] makeXMLSafe(char[] csvValue) {
		// replace special XML characters : & @ < > gt, lt, quot, amp, apos
		/*
    double quotes ( " ) are escaped to &quot;
    ampersand ( & ) is escaped to &amp;
    single quotes ( ' ) are escaped to &apos;
    less than ( < ) is escaped to &lt;
    greater than ( > ) is escaped to &gt;		 * 
		 */
		//return StringEscapeUtils.escapeXml(csvValue);
		csvValue = replaceStrings(csvValue, "&", "&amp;"); // must be first
		csvValue = replaceStrings(csvValue, "\"", "&quot;");
		csvValue = replaceStrings(csvValue, "'", "&apos;");
		csvValue = replaceStrings(csvValue, "<", "&lt;");
		csvValue = replaceStrings(csvValue, ">", "&gt;");
		return csvValue;
	}


	private static char[] replaceStrings(char[] cb, String fromStr, String toStr) {
		int ind = 0, start = 0;
		while( (ind = indexOf(cb,fromStr.toCharArray(),start) ) >= 0 ) {
			int end = ind + fromStr.length();
			cb = replaceChars(cb, ind, end-1, toStr.toCharArray() );
			start = end+1;
		}
		return cb;
	}


	private static char[] formatConvert(char[] csvValue, String csvFormat) {
			String[] formats = csvFormat.split("\\,");
			
			switch (formats[0]) {
            case "DATE":  
            	return dateConvert(csvValue, formats[1]);
            case "FIXED":  
            	csvValue = formats[1].toCharArray();
            	return csvValue;
			}
        	return csvValue;
	}

	// csvValue = 1990-01-01
	// templateStr DD.MM.YYYY

	private static char[] dateConvert(char[] csvValue, String csvFormat) {
		// convert cssValue to YYYY-MM-YY eg 1933-11-15
		try {
			String csv = new String(csvValue); // no need to worry about wierd char.. this is a date value!
			String year  = getYear(  csv, csvFormat);
			String month = getMonth( csv, csvFormat);
			String day   = getDay(   csv, csvFormat);
			String retStr = year+"-"+month+"-"+day;
			csvValue = retStr.toCharArray();
		} catch (Exception e) {
		}
		return csvValue;
	}


	// return the DD fields
	private static String getDay(String csvValue, String csvFormat) {
		int st = csvFormat.indexOf("D");
		return csvValue.substring(st, st+2);
	}


	private static String getMonth(String csvValue, String csvFormat) {
		int st = csvFormat.indexOf("M");
		return csvValue.substring(st, st+2);
	}


	private static String getYear(String csvValue, String csvFormat) {
		int st = csvFormat.indexOf("Y");
		return csvValue.substring(st, st+4);
	}





	final static int RAU_FILE_SIZE = 21970;
	final static int D_FILE_SIZE = 752;

	public static StringBuffer parseTemplate(String RAUXMLTemplate)
			throws IOException {
		File fil = new File(".");
		String pathName = fil.getAbsolutePath();
		/** windows* */
		// String path = pathName + "\\" + RAUXMLTemplate;
		/** unix* */
		String path = pathName + "/" + RAUXMLTemplate;
		// System.out.println("path%%%"+path);
		FileReader fr = new FileReader(path);
		BufferedReader br = new BufferedReader(fr);
		char[] update_xml = new char[RAU_FILE_SIZE];
		StringBuffer update_xml_buf = new StringBuffer();
		br.read(update_xml, 0, RAU_FILE_SIZE);
		update_xml_buf.append(update_xml);
		// System.out.println(update_xml_buf.toString());
		return update_xml_buf;
	}

	public static HashMap parsePropertyFile(String FileName) throws IOException {
		File fil = new File(".");
		String pathName = fil.getAbsolutePath();
		/** windows* */
		// String path = pathName + "\\" + FileName;
		/** unix* */
		String path = pathName + "/" + FileName;
		HashMap values = new HashMap();
		FileReader rs = new FileReader(path);
		BufferedReader in = new BufferedReader(rs);
		String item;
		while ((item = in.readLine()) != null) {
			StringTokenizer st1 = new StringTokenizer(item, "=");
			while (st1.hasMoreTokens()) {
				String key = st1.nextToken();
				String value = st1.nextToken();
				// System.out.println("value property"+value);
				values.put(key, value);
			}

		}
		return values;
	}


}
